﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BlockSet : MonoBehaviour
{
    // Start is called before the first frame update
    public GameObject block2;             // コピー元になるブロックオブジェクト
    public List<GameObject> list_block;   // 構成するブロックのリスト
    public List<Vector3> list_basePos;    // 構成するブロックの座標リスト
    public Color cr;                      // 色
    public List<bool> list_dummy;         // ダミー

    void Start()
    {
        int i, x, y, z;
        list_block = new List<GameObject>();
        list_basePos = new List<Vector3>();
        i = 0;

        // ブロックを敷き詰める(表示状態で形状を管理する)
        for (y = 0; y < 3; y++)
        {
            for (z = 0; z < 3; z++)
            {
                for (x = 0; x < 3; x++)
                {
                    //Debug.Log("add");
                    list_block.Add(Instantiate(block2, new Vector3(x, y, z), transform.rotation));
                    list_block[i].SetActive(false);
                    list_basePos.Add(new Vector3(x, y, z));
                    i++;

                    list_dummy.Add(false);
                    //Debug.Log("i=" + i.ToString());
                }

            }
        }

        // コピー元のブロックは非表示にしておく
        block2.SetActive(false);

        // ブロックの形状をランダムに決める
        Block_New();
    }

    // Update is called once per frame
    void Update()
    {
      
    }


    public int Block_New()
    {
        /* ランダムにブロックの形状を変更する関数 */
        int i;
        Debug.Log("NewBlock");

        // 5パターン
        int ptn = Random.Range(0, 5);

        // 色を赤で初期化
        cr = Color.red;

        // 全ブロックを非表示
        for(i=0; i < 27; i++)
        {
            list_block[i].SetActive(false);
        }

        switch (ptn)
        {
            case 0: // 凸
                list_block[12].SetActive(true);
                list_block[13].SetActive(true);
                list_block[14].SetActive(true);
                list_block[22].SetActive(true);
                cr = Color.yellow;
                break;
            case 1: // L
                list_block[12].SetActive(true);
                list_block[13].SetActive(true);
                list_block[14].SetActive(true);
                list_block[23].SetActive(true);
                cr = Color.red;
                break;
            case 2: // 田
                list_block[4].SetActive(true);
                list_block[5].SetActive(true);
                list_block[13].SetActive(true);
                list_block[14].SetActive(true);
                cr = Color.blue;
                break;
            case 3: // □□□
                list_block[12].SetActive(true);
                list_block[13].SetActive(true);
                list_block[14].SetActive(true);
                cr = Color.cyan;
                break;
            case 4: // Z
                list_block[4].SetActive(true);
                list_block[5].SetActive(true);
                list_block[12].SetActive(true);
                list_block[13].SetActive(true);
                cr = Color.magenta;
                break;
            case 5:
                break;
        }
        

        // 色を変更
        for (i = 0; i < 27; i++)
        {
            list_block[i].GetComponent<Renderer>().material.color = cr;
        }

        return 1;
    }

    public void Block_Move(int mx, int my, int mz)
    {
        // ブロックを指定座標に動かす（描画位置)
        int i, x, y, z;
        i = 0;
        for (y = 0; y < 3; y++)
        {
            for (z = 0; z < 3; z++)
            {
                for (x = 0; x < 3; x++)
                {
                    list_block[i].transform.position = new Vector3(list_basePos[i].x + mx, list_basePos[i].y + my, list_basePos[i].z + mz);
                    i++;
                }
            }
        }
    }

   public bool IsMove(int mx, int my, int mz)
   {
        /* 移動可能判定(不使用) Field側に実装 */
        bool ret = true;
        Debug.Log(mx.ToString() + "," + my.ToString() + "," + mz.ToString()); ;
        for(int i=0; i<27; i++)
        {
            if (list_block[i].activeInHierarchy == false)
                continue;

            if (list_basePos[i].x + mx < 0 || list_basePos[i].x + mx > 3)
                return false;

            if (list_basePos[i].y + my < 0 || list_basePos[i].y + my > 15)
                return false;

            if (list_basePos[i].z + mz < 0 || list_basePos[i].z + mz > 3)
                return false;
        }

        return ret;
    } 

    public void RotateX()
    {
        /* ブロックの回転処理(X軸) */
        int i;
        List<bool> listFlag = new List<bool>();
        for (i = 0; i < 27; i++)
            listFlag.Add(false);

        // 回転後の位置リスト
        var rot = new List<int>() {18 , 19, 20, 9, 10, 11, 0, 1, 2,
               21, 22, 23, 12, 13, 14, 3, 4, 5,
               24, 25, 26, 15, 16, 17, 6, 7, 8
        };

        for (i = 0; i < 27; i++)
            listFlag[i] = list_block[rot[i]].activeInHierarchy;

        for (i = 0; i < 27; i++)
            list_block[i].SetActive(listFlag[i]);
    }

    public void DummyRotateX()
    {
        /* ダミーブロックの回転処理(X軸) */
        int i;
        List<bool> listFlag = new List<bool>();
        for (i = 0; i < 27; i++)
            listFlag.Add(false);

        var rot = new List<int>() {18 , 19, 20, 9, 10, 11, 0, 1, 2,
               21, 22, 23, 12, 13, 14, 3, 4, 5,
               24, 25, 26, 15, 16, 17, 6, 7, 8
        };

        for (i = 0; i < 27; i++)
            listFlag[i] = list_block[rot[i]].activeInHierarchy;

        for (i = 0; i < 27; i++)
            list_dummy[i] = list_block[i];
    }

    public void RotateY()
    {
        /* ブロックの回転処理(Y軸) */
        int i;
        List<bool> listFlag = new List<bool>();
        for(i=0; i<27; i++)
        {
            listFlag.Add(false);
            // listFlag[i] = false;
        }

        /*
        var rot = new List<int>() {3, 7, 11, 15, 2, 6, 10, 14, 1, 5, 9, 13, 0, 3, 8, 12,
                       19, 23, 27, 31, 18, 22, 26, 30, 17, 21, 25, 29, 16, 20, 24, 28,
                       35, 39, 43, 47, 34, 38, 42, 46, 33, 37, 41, 45, 32, 36, 40, 44,
                       51, 55, 59, 63, 50, 54, 58, 62, 49, 53, 57, 61, 48, 52, 56, 60
        };
        */

        var rot = new List<int>() {2 , 5, 8, 1, 4, 7, 0, 3, 6, 
               11, 14, 17, 10, 13, 16, 9, 12, 15,
               20, 23, 26, 19, 22, 25, 18, 21, 24
        };

        for (i=0; i<27; i++)
        {
            listFlag[i] = list_block[rot[i]].activeInHierarchy;
        }

        for (i = 0; i < 27; i++)
        {
            list_block[i].SetActive(listFlag[i]);
        }
    }

    public void DummyRotateY()
    {
        int i;
        /* ダミーブロックの回転処理(Y軸) */
        List<bool> listFlag = new List<bool>();
        for (i = 0; i < 27; i++)
        {
            listFlag.Add(false);
            // listFlag[i] = false;
        }

        var rot = new List<int>() {2 , 5, 8, 1, 4, 7, 0, 3, 6,
               11, 14, 17, 10, 13, 16, 9, 12, 15,
               20, 23, 26, 19, 22, 25, 18, 21, 24
        };

        for (i = 0; i < 27; i++)
        {
            listFlag[i] = list_block[rot[i]].activeInHierarchy;
        }

        for (i = 0; i < 27; i++)
        {
            list_dummy[i] = list_block[i];
        }
    }


    public List<Vector3> GetActiveBlockArray(int mx, int my, int mz)
    {
        /* アクティブなブロックの座標リストを返す(オフセット位置を加算) */
        List<Vector3> list = new List<Vector3>();
        Vector3 v;
        list.Clear();
        for (int i = 0; i < 27; i++)
        {
            if (list_block[i].activeInHierarchy == false)
                continue;

            v.x = list_basePos[i].x + mx;
            v.y = list_basePos[i].y + my;
            v.z = list_basePos[i].z + mz;

            list.Add(v);
        }
        return list;
    }

    // ダミーブロックの配列を取得
    public List<Vector3> GetDummyBlockArray(int mx, int my, int mz)
    {
        List<Vector3> list = new List<Vector3>();
        Vector3 v;
        list.Clear();
        for (int i = 0; i < 27; i++)
        {
            if (list_dummy[i] == false)
                continue;

            v.x = list_basePos[i].x + mx;
            v.y = list_basePos[i].y + my;
            v.z = list_basePos[i].z + mz;

            list.Add(v);
        }
        return list;
    }
}
